from . import packets
from .generic import GamePacket, GamePacketRegistry


def get_packet_registry():
    new_registry = GamePacketRegistry()
    new_registry.register(packets.meta.ProtocolSyncPacket, 1)
    new_registry.register(packets.meta.TransactionPacket)
    new_registry.register(packets.meta.LoginPacket)
    new_registry.register(packets.meta.RemovedPlayerPacket)
    new_registry.register(packets.general.EndTickPacket)
    new_registry.register(packets.meta.WorldRecievedGamePacket)
    new_registry.register(packets.meta.SetNetworkSetting)
    new_registry.register(packets.meta.ChallengeLoginPacket)
    new_registry.register(packets.meta.ItchSessionTokenPacket)
    new_registry.register(packets.entities.PlayerSkinPacket)
    new_registry.register(packets.entities.PlayerPacket)
    new_registry.register(packets.general.MessagePacket)
    new_registry.register(packets.entities.PlayerPositionPacket)
    new_registry.register(packets.entities.EntityPositionPacket)
    new_registry.register(packets.entities.NoClipPacket)
    new_registry.register(packets.general.ZonePacket)
    new_registry.register(packets.general.ChunkColumnPacket)
    new_registry.register(packets.general.CommandPacket)
    new_registry.register(packets.meta.DisconnectPacket)
    new_registry.register(packets.blocks.PlaceBlockPacket)
    new_registry.register(packets.blocks.BreakBlockPacket)
    new_registry.register(packets.blocks.InteractBlockPacket)
    new_registry.register(packets.blocks.BlockReplacePacket)
    new_registry.register(packets.sounds.PlaySound2DPacket)
    new_registry.register(packets.sounds.PlaySound3DPacket)
    new_registry.register(packets.items.DropItemPacket)
    new_registry.register(packets.items.SlotInteractPacket)
    new_registry.register(packets.items.ContainerSyncPacket)
    new_registry.register(packets.blockentities.BlockEntityScreenPacket)
    new_registry.register(packets.blockentities.BlockEntityDataPacket)
    new_registry.register(packets.blockentities.SignsEntityPacket)
    new_registry.register(packets.items.RequestGiveItemPacket)
    new_registry.register(packets.items.SlotSyncPacket)
    new_registry.register(packets.items.SlotMergePacket)
    new_registry.register(packets.items.SlotSwapPacket)
    new_registry.register(packets.entities.SpawnEntityPacket)
    new_registry.register(packets.entities.DespawnEntityPacket)
    new_registry.register(packets.entities.AttackEntityPacket)
    new_registry.register(packets.entities.InteractEntityPacket)
    new_registry.register(packets.entities.HitEntityPacket)
    new_registry.register(packets.entities.MaxHPEntityPacket)
    new_registry.register(packets.entities.RespawnPacket)
    new_registry.register(packets.general.ParticleSystemPacket)
    new_registry.register(packets.sounds.SetMusicTagsPacket)
    new_registry.register(packets.sounds.ForceSongChangePacket)
    return new_registry


__all__ = ["GamePacket", "GamePacketRegistry", "get_packet_registry", "packets"]
